apiVersion: apps/v1
kind: Deployment
metadata:
  name: {{ include "snowplow-rdb-loader.fullname" . }}-rdb-loader
  labels:
    {{- include "snowplow-rdb-loader.labels" . | nindent 4 }}
spec:
{{- if not .Values.rdbLoader.autoscaling.enabled }}
  replicas: {{ .Values.replicaCount }}
{{- end }}
  selector:
    matchLabels:
      {{- include "snowplow-rdb-loader.selectorLabels" . | nindent 6 }}
  template:
    metadata:
      annotations:
        {{- with .Values.podAnnotations }}
        {{- toYaml . | nindent 8 }}
        {{- end }}
        checksum/configMap: {{ include (print $.Template.BasePath "/configMap.yaml") $ | sha256sum }}
      labels:
        {{- include "snowplow-rdb-loader.selectorLabels" . | nindent 8 }}
    spec:
      {{- with .Values.imagePullSecrets }}
      imagePullSecrets:
        {{- toYaml . | nindent 8 }}
      {{- end }}
      serviceAccountName: {{ include "snowplow-rdb-loader.serviceAccountName" . }}
      automountServiceAccountToken: true
      securityContext:
        {{- toYaml .Values.rdbLoader.podSecurityContext | nindent 8 }}
      containers:
        - name: {{ .Chart.Name }}
          securityContext:
            {{- toYaml .Values.rdbLoader.securityContext | nindent 12 }}
          image: "{{ .Values.rdbLoader.image.repository }}:{{ .Values.rdbLoader.image.tag }}"
          imagePullPolicy: {{ .Values.rdbLoader.image.pullPolicy }}
          command: [
            "sh",
            "-c",
            "bin/snowplow-rdb-loader --config $(cat /opt/configs/config.hocon | base64 -w 0) --iglu-config $(cat /opt/configs/iglu_resolver.json | base64 -w 0)"
          ]
          envFrom:
          - secretRef:
              name: {{ .Values.secretKeyRef | default (include "snowplow-rdb-loader.fullname" .) }}
          resources:
            {{- toYaml .Values.resources | nindent 12 }}
          volumeMounts:
            - name: configs
              mountPath: /opt/configs/config.hocon
              subPath: config.hocon
            - name: configs
              mountPath: /opt/configs/iglu_resolver.json
              subPath: iglu_resolver.json
      {{- with .Values.nodeSelector }}
      nodeSelector:
        {{- toYaml . | nindent 8 }}
      {{- end }}
      {{- with .Values.affinity }}
      affinity:
        {{- toYaml . | nindent 8 }}
      {{- end }}
      {{- with .Values.tolerations }}
      tolerations:
        {{- toYaml . | nindent 8 }}
      {{- end }}
      volumes:
        - name: configs
          configMap: 
            name: {{ template "snowplow-rdb-loader.fullname" $ }} 
